import java.text.ParseException;
import java.util.ArrayList;
import java.util.Vector;

import javax.sdp.Attribute;
import javax.sdp.Connection;
import javax.sdp.MediaDescription;
import javax.sdp.Origin;
import javax.sdp.SdpConstants;
import javax.sdp.SdpException;
import javax.sdp.SdpFactory;
import javax.sdp.SessionDescription;
import javax.sdp.SessionName;
import javax.sdp.Version;
import javax.sip.InvalidArgumentException;
import javax.sip.address.Address;
import javax.sip.address.SipURI;
import javax.sip.header.CSeqHeader;
import javax.sip.header.CallIdHeader;
import javax.sip.header.ContactHeader;
import javax.sip.header.ContentTypeHeader;
import javax.sip.header.FromHeader;
import javax.sip.header.MaxForwardsHeader;
import javax.sip.header.ToHeader;
import javax.sip.header.ViaHeader;
import javax.sip.message.Request;

public class PCSButton extends UAbutton {
	
	public PCSButton() {
		super.PCS_LOCAL_IP = "192.168.71.196";
		super.PCS_LOCAL_PORT = 5656;
		super.PCS_REMOTE_ADDR = "192.168.71.196:4321";
		super.PCS_REMOTE_FILENAME = "smoking.mpeg";
	}
	
	public Request GetPCSRequest(PCSParameter pcsParam) throws ParseException,
			InvalidArgumentException {
		// create FromHeader
		SipURI fromAddress = pcsParam.addressFactory.createSipURI(
				pcsParam.fromUserName, pcsParam.fromSipAddress);
		Address fromNameAddress = pcsParam.addressFactory
				.createAddress(pcsParam.fromSipAddress);
		fromNameAddress.setDisplayName(pcsParam.fromDisplayName);
		FromHeader fromHeader = pcsParam.headerFactory.createFromHeader(
				fromNameAddress, pcsParam.fromTag);
		
		// lUSIP headerݭnѦPǦۤv@
		
		// create ToHeader
		SipURI toAddress = pcsParam.addressFactory.createSipURI(
				pcsParam.toUserName, pcsParam.toSipAddress);
		Address toNameAddress = pcsParam.addressFactory
				.createAddress(toAddress);
		toNameAddress.setDisplayName(pcsParam.toDisplayName);
		ToHeader toHeader = pcsParam.headerFactory.createToHeader(
				toNameAddress, pcsParam.toTag);
		
		// create Request URI
		SipURI requestURI = pcsParam.addressFactory.createSipURI(
		pcsParam.toUserName, pcsParam.requestHostPort);

		// Create ViaHeaders
		ArrayList viaHeaders = new ArrayList();
		ViaHeader viaHeader = pcsParam.headerFactory.createViaHeader(
				pcsParam.UAIPaddr, pcsParam.UASIPPort,
				pcsParam.Transport_Portocol, null);
		// add via headers
		viaHeaders.add(viaHeader);

		// Create a new Call-Id Header
		CallIdHeader callIdHeader = pcsParam.callIdHeader;
		
		// Create a new MaxForwards Header
		MaxForwardsHeader maxForwards = pcsParam.maxForwardHeader;
		
		// Create a new Cseq header
		CSeqHeader cSeqHeader = null;	//TODO (1)  CSeq Header

		// Create the request.
		Request request = pcsParam.messageFactory.createRequest(requestURI,
		Request.INVITE, callIdHeader, cSeqHeader, fromHeader,
		toHeader, viaHeaders, maxForwards);

		// Create the contact name address.
		SipURI contactURI = null;		//TODO (2)  Contact URI
		contactURI.setPort(0);			//TODO     ]w Contact port
		Address contactAddress = pcsParam.addressFactory
				.createAddress(contactURI);

		// Add the contact address.
		contactAddress.setDisplayName("");
		ContactHeader contactHeader = pcsParam.headerFactory
				.createContactHeader(contactAddress);
		request.addHeader(contactHeader);

		// ====================create sdp======================
		SdpFactory sdpFactory = SdpFactory.getInstance();
		String sdpData = null;		

		try { // ======use SessionDescription to package all parameter
			SessionDescription sd = sdpFactory.createSessionDescription();

			// v= Protocol version.
			Version version = sdpFactory.createVersion(0);

			// o=. Owner/creator and session identifier.
			// createOrigin(String userName, String address)
			Origin origin = null;			//TODO (3)  Origin 

			// c=. Connection information.
			// createConnection(String netType,String addrType, String addr)
			// Returns a Connection object with the specified properties and
			// a network and address type of "IN" and "IP4" respectively.
			Connection connection = null;	//TODO (4)  Connection 

			// s=. Session name.
			// createSessionName(String name)
			// Returns SessionName object with the specified name.
			SessionName sessionname = sdpFactory
					.createSessionName("Session from UA to Rsc");

			sd.setVersion(version);
			sd.setOrigin(origin);
			sd.setConnection(connection);
			sd.setSessionName(sessionname);

			// createMediaDescription(String media,int port,int
			// numPorts,String transport,String[] formats)
			String[] format = new String[1];
			format[0] = Integer.toString(SdpConstants.PCMU);

			Vector mds = new Vector();
			MediaDescription md1 = sdpFactory.createMediaDescription(
					"video", pcsParam.videoRTPPort, 1, "RTP/AVP", format);
			MediaDescription md2 = null;	//TODO (5)  Audio RTP port

			Vector attrs1 = new Vector();
			Vector attrs2 = new Vector();
			
			// ***** ]w Video RTCP port Ψ䥦RTPѼ *****
			Attribute attr1 = sdpFactory.createAttribute("rtcp", ""+pcsParam.videoRTCPPort); // Video RTCP port
			Attribute attr2 = sdpFactory.createAttribute("rtpmap",
					"0 pcmu/8000");
			Attribute attr3 = sdpFactory.createAttribute("recvonly", null);
			attrs1.addElement(attr1);
			attrs1.addElement(attr2);
			attrs1.addElement(attr3);
			
			// ***** ]w Aideo RTCP port Ψ䥦RTPѼ *****	
			attr1 = null;					//TODO (6)  Audio RTCP port

			attrs2.addElement(attr1);
			attrs2.addElement(attr2);
			attrs2.addElement(attr3);

			md1.setAttributes(attrs1);
			md2.setAttributes(attrs2);
			mds.addElement(md1);
			mds.addElement(md2);
			sd.setMediaDescriptions(mds);

			sdpData = sd.toString();

		} catch (SdpException ex) {
			System.err.print(ex.toString());
		}
		
		
		byte[] contents = sdpData.getBytes();
		
		// Create ContentTypeHeader
		ContentTypeHeader contentTypeHeader = pcsParam.contentHeader;
		request.setContent(contents, contentTypeHeader);
		
		return request;
	}

	public static void main(String[] args) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new PCSButton().setVisible(true);
			}
		});
	}

}
